/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */   //打开网站
//打开网站
package net.micode.notes.tool;//定义小米便签类：功能类
//.调用了Android的包
import android.content.Context;//导入所需类
import android.database.Cursor;//android查询数据库类
import android.os.Environment;//安卓操作系统环境包
import android.text.TextUtils;
import android.text.format.DateFormat;
import android.util.Log;

import net.micode.notes.R;
import net.micode.notes.data.Notes;
import net.micode.notes.data.Notes.DataColumns;
import net.micode.notes.data.Notes.DataConstants;
import net.micode.notes.data.Notes.NoteColumns;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;


public class BackupUtils {// 类：备份工具类，从备份文件中恢复便签
    private static final String TAG = "BackupUtils";//实例化一个backupUtils的对象
    // Singleton stuff
    private static BackupUtils sInstance;//同步线程锁，其他试图访问该方法的线程将受到阻塞

    public static synchronized BackupUtils getInstance(Context context) {//.如果当前备份不存在，则新声明一个
        if (sInstance == null) {//若当前备份不存在，则新声明一个
            sInstance = new BackupUtils(context);//如果没有备份文件，则进行声明
        }
        return sInstance;//我的标注
    }

    /**
     * Following states are signs to represents backup or restore  以下状态表示备份或恢复
     * status
     */
    // Currently, the sdcard is not mounted
    public static final int STATE_SD_CARD_UNMOUONTED           = 0;//备份文件夹不存在
    // The backup file not exist
    public static final int STATE_BACKUP_FILE_NOT_EXIST        = 1;//数据已被破坏，可能被修改
    // The data is not well formated, may be changed by other programs
    public static final int STATE_DATA_DESTROIED               = 2;//系统出现错误
    // Some run-time exception which causes restore or backup fails
    public static final int STATE_SYSTEM_ERROR                 = 3;//导出成功
    // Backup or restore success
    public static final int STATE_SUCCESS                      = 4;//变量：表示备份成功

    private TextExport mTextExport;//实例化一个TextExport的对象mTextExport

    private BackupUtils(Context context) {//初始化函数

        mTextExport = new TextExport(context);//初始化函数
    }

    private static boolean externalStorageAvailable() {//外部存储设备是否有效
        return Environment.MEDIA_MOUNTED.equals(Environment.getExternalStorageState());//函数：根据外部存储设备的状态判断是否可以存储
    }

    public int exportToText() {//输出至文本

        return mTextExport.exportToText();//返回输出文本后的状态（以上定义的五种状态中一种）
    }

    public String getExportedTextFileName() {//获取输出的文本文件名

        return mTextExport.mFileName;
    }

    public String getExportedTextFileDir() {//返回文件的路径

        return mTextExport.mFileDirectory;
    }

    private static class TextExport {//内部类：文本输出定义笔记ID、修改日期等，笔记、内容、日期、电话号码的数据和格式等常量
        private static final String[] NOTE_PROJECTION = {//定义了一个数组储存便签的信息
                NoteColumns.ID,
                NoteColumns.MODIFIED_DATE,
                NoteColumns.SNIPPET,
                NoteColumns.TYPE
        };//下面三行初始化note数组里的属性值

        private static final int NOTE_COLUMN_ID = 0;//定义了一个数组储存的是数据的信息

        private static final int NOTE_COLUMN_MODIFIED_DATE = 1;//下面几行同样初始化data数组里属性值

        private static final int NOTE_COLUMN_SNIPPET = 2;//初始化上述一些参数

        private static final String[] DATA_PROJECTION = {//数据在数据库中的信息
                DataColumns.CONTENT,
                DataColumns.MIME_TYPE,// 变量：该资源的媒体类型，决定怎么用这个资源
                DataColumns.DATA1,//. 数据列组1
                DataColumns.DATA2,
                DataColumns.DATA3,
                DataColumns.DATA4,
        };//context类实例用于传递内容
// 标识设定：数据内容标识为0；媒体类型标识为1；访问日期标识为2；电话号码标识为4；
        private static final int DATA_COLUMN_CONTENT = 0;

        private static final int DATA_COLUMN_MIME_TYPE = 1;

        private static final int DATA_COLUMN_CALL_DATE = 2;

        private static final int DATA_COLUMN_PHONE_NUMBER = 4;

        private final String [] TEXT_FORMAT;//文档格式标识：名称=>0;日期=>1;内容=>2
        private static final int FORMAT_FOLDER_NAME          = 0;//之前文件名格式赋值为0
        private static final int FORMAT_NOTE_DATE            = 1;//便签内容数据格式
        private static final int FORMAT_NOTE_CONTENT         = 2;//便签目录格式

        private Context mContext;// 为该类定义一个私有的上下文类
        private String mFileName;//定义文件名
        private String mFileDirectory;//定义一个文件名的字符串

        public TextExport(Context context) {//.从context类实例中获取信息，给对应的属性赋初始值
            TEXT_FORMAT = context.getResources().getStringArray(R.array.format_for_exported_note);//根据文件定义的地址处获取文件格式的数组
            mContext = context;//文件内容为便签内容
            mFileName = "";//文件名初始化为空
            mFileDirectory = "";// 文件路径初始化为空
        }

        private String getFormat(int id) {//.获取文本组成部分

            return TEXT_FORMAT[id];
        }

        /**
         * Export the folder identified by folder id to text 输出文件夹
         */
        private void exportFolderToText(String folderId, PrintStream ps) {//.通过查询parent id是文件夹id的note来选出制定ID文件夹下的Note
            // Query notes belong to this folder
            Cursor notesCursor = mContext.getContentResolver().query(Notes.CONTENT_NOTE_URI,//光标移动到文件夹ID处
                    NOTE_PROJECTION, NoteColumns.PARENT_ID + "=?", new String[] {
                        folderId
                    }, null);//如果查询结果非空那么按照时间格式输出最后修改的时间

            if (notesCursor != null) {//ps里面保存有这份note的日期
                if (notesCursor.moveToFirst()) {//设置noteID然后查看note的数据
                    do {
                        // Print note's last modified date
                        ps.println(String.format(getFormat(FORMAT_NOTE_DATE), DateFormat.format(//函数：打印最后修改日期
                                mContext.getString(R.string.format_datetime_mdhm),
                                notesCursor.getLong(NOTE_COLUMN_MODIFIED_DATE))));
                        // Query data belong to this note
                        String noteId = notesCursor.getString(NOTE_COLUMN_ID);//代码块：通过将便签内容打印到屏幕上检查是不是这个note的数据
                        exportNoteToText(noteId, ps);//通过打印输出流输出到文本中
                    } while (notesCursor.moveToNext());//语句：遍历这个文件夹底下所有的便签
                }
                notesCursor.close();//关闭游标
            }
        }

        /**
         * Export note identified by id to a print stream
         */
        private void exportNoteToText(String noteId, PrintStream ps) {//函数：将便签的内容以文本的形式显示在屏幕上。比如电话号码、打电话的日期等。
            Cursor dataCursor = mContext.getContentResolver().query(Notes.CONTENT_DATA_URI,
                    DATA_PROJECTION, DataColumns.NOTE_ID + "=?", new String[] {
                        noteId
                    }, null);

            if (dataCursor != null) {//如果数据游标不为空
                if (dataCursor.moveToFirst()) {//如果游标执行到第一步
                    do {
                        String mimeType = dataCursor.getString(DATA_COLUMN_MIME_TYPE);// 获得便签的媒体类型
                        if (DataConstants.CALL_NOTE.equals(mimeType)) {// 语句：判断便签的内容，如果是电话记录，那么在这一个代码块内打印
                            // Print phone number
                            String phoneNumber = dataCursor.getString(DATA_COLUMN_PHONE_NUMBER);//电话号码、通话记录、便签数据内容赋值
                            long callDate = dataCursor.getLong(DATA_COLUMN_CALL_DATE);//获取通话时间
                            String location = dataCursor.getString(DATA_COLUMN_CONTENT);//获取地址

                            if (!TextUtils.isEmpty(phoneNumber)) {//判断是否是空字符
                                ps.println(String.format(getFormat(FORMAT_NOTE_CONTENT),//输出电话号码phoneNumber
                                        phoneNumber));
                            }
                            // Print call date
                            ps.println(String.format(getFormat(FORMAT_NOTE_CONTENT), DateFormat//输出calldate
                                    .format(mContext.getString(R.string.format_datetime_mdhm),
                                            callDate)));
                            // Print call attachment location
                            if (!TextUtils.isEmpty(location)) {//输出位置location
                                ps.println(String.format(getFormat(FORMAT_NOTE_CONTENT),//打印便签格式和位置信息
                                        location));
                            }
                        } else if (DataConstants.NOTE.equals(mimeType)) {//语句：如果是便签的内容，那么直接输出便签里面包含的东西
                            String content = dataCursor.getString(DATA_COLUMN_CONTENT);
                            if (!TextUtils.isEmpty(content)) {//如果便签内容不为空值
                                ps.println(String.format(getFormat(FORMAT_NOTE_CONTENT),//将note内容输出到PrintStream流中
                                        content));
                            }//文本间进行空行
                        }
                    } while (dataCursor.moveToNext());//光标下移
                }
                dataCursor.close();//关闭游标
            }
            // print a line separator between note
            try {//语句块：在note下面输出一条线
                ps.write(new byte[] {//在note下面输出一条线
                        Character.LINE_SEPARATOR, Character.LETTER_NUMBER
                });
            } catch (IOException e) {// 代码块：获取错误信息
                Log.e(TAG, e.toString());//捕获错误信息并记录异常日志
            }
        }

        /**
         * Note will be exported as text which is user readable
         */
        public int exportToText() {//以TEXT形式输出到外部设备
            if (!externalStorageAvailable()) {//如果SD卡未安装好，返回对应状态
                Log.d(TAG, "Media was not mounted");//检查外部设备安装情况，如果未安装好，则蓝色字体输出debug信息，并返回STATE_SD_CARD_UNMOUNOTED值为0
                return STATE_SD_CARD_UNMOUONTED;
            }

            PrintStream ps = getExportToTextPrintStream();//语句：获取存储路径
            if (ps == null) {//输出文件夹和笔记
                Log.e(TAG, "get print stream error");//语句块：如果ps赋值失败，则输出显示错误的信息，并返回状态错误信息
                return STATE_SYSTEM_ERROR;
            }
            // First export folder and its notes
            Cursor folderCursor = mContext.getContentResolver().query(//找到相应的文件夹
                    Notes.CONTENT_NOTE_URI,
                    NOTE_PROJECTION,
                    "(" + NoteColumns.TYPE + "=" + Notes.TYPE_FOLDER + " AND "
                            + NoteColumns.PARENT_ID + "<>" + Notes.ID_TRASH_FOLER + ") OR "
                            + NoteColumns.ID + "=" + Notes.ID_CALL_RECORD_FOLDER, null, null);

            if (folderCursor != null) {//语句块：导出文件夹，把里面的便签导出来。
                if (folderCursor.moveToFirst()) {//文件夹光标在第一行就位
                    do {
                        // Print folder's name   打印文件夹名称
                        String folderName = "";//输出文件名
                        if(folderCursor.getLong(NOTE_COLUMN_ID) == Notes.ID_CALL_RECORD_FOLDER) {//语句块：根据folder在数据库中的位置来找到文件名
                            folderName = mContext.getString(R.string.call_record_folder_name);
                        } else {
                            folderName = folderCursor.getString(NOTE_COLUMN_SNIPPET);//语句：否则从便签小片中取前面一部分字符串为foldername

                        }
                        if (!TextUtils.isEmpty(folderName)) {//语句块：根据文件名来查看folder是否有内容，有的话就按照格式输出文件名
                            ps.println(String.format(getFormat(FORMAT_FOLDER_NAME), folderName));
                        }
                        String folderId = folderCursor.getString(NOTE_COLUMN_ID);//通过便签id得到folderID
                        exportFolderToText(folderId, ps);// 方法：调用上面实现过的方法来把文件夹里面的内容导出打印
                    } while (folderCursor.moveToNext());// 文件夹的光标下移
                }
                folderCursor.close();//关闭游标
            }

            // Export notes in root's folder
            Cursor noteCursor = mContext.getContentResolver().query(//输出根目录下的笔记
                    Notes.CONTENT_NOTE_URI,
                    NOTE_PROJECTION,
                    NoteColumns.TYPE + "=" + +Notes.TYPE_NOTE + " AND " + NoteColumns.PARENT_ID
                            + "=0", null, null);

            if (noteCursor != null) {//输出修改的时间
                if (noteCursor.moveToFirst()) {//访问便签数据
                    do {
                        ps.println(String.format(getFormat(FORMAT_NOTE_DATE), DateFormat.format(//将便签的修改日期显示在屏幕上。
                                mContext.getString(R.string.format_datetime_mdhm),
                                noteCursor.getLong(NOTE_COLUMN_MODIFIED_DATE))));
                        // Query data belong to this note  访问便签中的数据的相关信息
                        String noteId = noteCursor.getString(NOTE_COLUMN_ID);// 找到这块数据的ID.
                        exportNoteToText(noteId, ps);//.将便签导出至text
                    } while (noteCursor.moveToNext());// 便签光标下移
                }
                noteCursor.close();//关闭游标
            }
            ps.close();

            return STATE_SUCCESS;//语句：返回成功导出的状态
        }

        /**
         * Get a print stream pointed to the file {@generateExportedTextFile}
         */
        private PrintStream getExportToTextPrintStream() {//获取指向文件的打印流
            File file = generateFileMountedOnSDcard(mContext, R.string.file_path,
                    R.string.file_name_txt_format);
            if (file == null) {//如果文件为空，则创建失败
                Log.e(TAG, "create file to exported failed");//记录异常日志
                return null;
            }
            mFileName = file.getName();//得到文件的名字
            mFileDirectory = mContext.getString(R.string.file_path);
            PrintStream ps = null;//将ps输出流输出到特定的文件，目的就是导出到文件，而不是直接输出
            try {//将ps输出流输出到特定的文件，目的就是导出到文件，而不是直接输出
                FileOutputStream fos = new FileOutputStream(file);//将ps输出流导出到文件
                ps = new PrintStream(fos);//将ps输出流输出到特定的文件，目的就是导出到文件，而不是直接输出
            } catch (FileNotFoundException e) {//找不到系统指定文件
                e.printStackTrace();
                return null;
            } catch (NullPointerException e) {//当对某一个NULL的对象进行操作的时候。
                e.printStackTrace();
                return null;
            }
            return ps;
        }
    }

    /**
     * Generate the text file to store imported data
     */  //实现一个函数：生成文件存储在外部存储器上
    private static File generateFileMountedOnSDcard(Context context, int filePathResId, int fileNameFormatResId) {//产生用于存储输入信息的文件
        StringBuilder sb = new StringBuilder();//语句块：构建一个动态字符串将外部存储器路径、文件路径、编辑时间加入到其中
        sb.append(Environment.getExternalStorageDirectory());//文件的存储路径
        sb.append(context.getString(filePathResId));//将当前的系统时间以预定的格式输出
        File filedir = new File(sb.toString());
        sb.append(context.getString(//将当前的系统时间以预定的格式输出
                fileNameFormatResId,
                DateFormat.format(context.getString(R.string.format_date_ymd),
                        System.currentTimeMillis())));
        File file = new File(sb.toString());//将输出连接到一个文件里

        try {//如果这些文件不存在，则新建
            if (!filedir.exists()) {
                filedir.mkdir();
            }
            if (!file.exists()) {
                file.createNewFile();
            }
            return file;// 语句：返回导出的文件
        } catch (SecurityException e) {//异常处理
            e.printStackTrace();
        } catch (IOException e) {//输入输出异常处理
            e.printStackTrace();
        }

        return null;//.try catch 异常处理
    }
}


